﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Jewels
{
    public partial class Game : Form
    {
        int score = 0;
        public DateTime endTime;
        public bool timerEnabled = false;
        
        Point selected = new Point(-1,-1);
        Map map;
        public Game(Map m) ///INICIALIZACE
        {
            map = m;
            InitializeComponent();
            this.SizeChanged += Game_SizeChanged;
            UpdateIt();
            this.Height = (int)(this.Width * 1.3);
            timer1.Enabled = timerEnabled;
        }

        private void Game_SizeChanged(object sender, EventArgs e)//ASPECT RATIO LOCK
        {

                this.Height = (int)(this.Width * 1.3);
            
        }
        private bool AreValidMove() //zjisteni jestli je tu NEJAKY mozny pohyb 
        {
            for (int x = 0; x < 8; x++)
            {
                for (int y = 0; y < 8; y++)
                {
                    var points = getValidTryPoints(new Point(x,y));
                    foreach (var item in points)
                    {
                        if (canMoveSoft(new Point(x, y), item))
                            return true;
                    }
                }
            }
            return false;
        }

        private void panel1_Paint(object sender, PaintEventArgs e)//vykresleni hlavni hry
        {
            var size = panel1.Size.Width / 8;
            Graphics g = e.Graphics;
            for (int x = 0; x < map.jewels.GetLength(0) ; x++)
            {
                for (int y = 0; y < map.jewels.GetLength(1) ; y++)
                {
                    g.FillRectangle(new SolidBrush(map.jewels[x,y].Color),x* size, y* size, size, size);
                    g.DrawRectangle(Pens.Black, x * size, y * size, size, size);
                }
            }
            if(selected != new Point(-1, -1))
                g.DrawRectangle(Pens.Orange, selected.X * size, selected.Y * size, size, size);
            var midSize = size + 0.5;
            for (int x = 0; x < 8; x++)
            {
                for (int y = 0; y < 8; y++)
                {
                    var points = getValidTryPoints(new Point(x, y));
                    foreach (var item in points)
                    {
                        if (canMoveSoft(new Point(x, y), item))
                            g.DrawLine(Pens.OrangeRed, (int)((x + 0.5) * size), (int)((y + 0.5) * size), (int)((item.X + 0.5) * size), (int)((item.Y+0.5) * size));
                    }
                }
            }
        }

        private void panel1_Resize(object sender, EventArgs e)
        {
            panel2.Invalidate();
            panel1.Invalidate();
        } // prekreslit po zmeni velikosti

        private void Game_Resize(object sender, EventArgs e)
        {

        } //UNUSED

        private void panel1_MouseClick(object sender, MouseEventArgs e) //provedeni clicku
        {
            var size = panel1.Size.Width / 8;
            var clickedPoint = new Point((int)(e.X / size), (int)(e.Y / size));

            if (selected != new Point(-1, -1))
            {
                TryToMove(selected,clickedPoint);
                selected = new Point(-1, -1);
            }
            else
            {
                selected = clickedPoint;
            }
            panel2.Invalidate();
            panel1.Invalidate();
            if (!AreValidMove())
                GameOver();
        }
        private bool TryToMove(Point original, Point Destination)
        {
            if (getValidPoints(original).Contains(Destination))
            {
                return canMove(original, Destination);
            }
            else
                return false;
            
        }

        internal void startTimer()
        {
            this.timer1.Enabled = true;
        }

        private void CascadeIt(List<Point> points)
        {
            foreach (var item in points)
            {
                map.jewels[item.X, item.Y] = map.jeweltypes[0];
            }
            for (int x = 7; x >= 0; x--)
            {
                CascadeCollum(x);
            }
        }
        private void CascadeCollum(int x)
        {
            for (int y = 0; y < 8; y++)
            {
                if(map.jewels[x,y].Id==0)
                {
                    if(y>0)
                    {
                        var orig = map.jewels[x, y];
                        var dest = map.jewels[x, y - 1];
                        map.jewels[x, y] = dest;
                        map.jewels[x, y - 1] = orig;
                        y = -1;
                    }
                    else
                    {
                        map.jewels[x, y] = map.getNext(x);
                        y = -1;
                    }
                }
            }
        }
        private bool canMoveSoft(Point original, Point Destination)
        {
            var Orig = map.jewels[original.X, original.Y];
            var Dest = map.jewels[Destination.X, Destination.Y];
            map.jewels[original.X, original.Y] = Dest;
            map.jewels[Destination.X, Destination.Y] = Orig;

            //
            for (int x = 0; x < map.jewels.GetLength(0); x++)
            {
                for (int y = 0; y < map.jewels.GetLength(1); y++)
                {
                    var toCheck = getForCheckPoints(new Point(x, y));
                    foreach (var item in toCheck)
                    {
                        bool success = true;
                        var type = map.get(item.First());
                        foreach (var inneritem in item)
                        {
                            if (type != map.get(inneritem))
                            {
                                success = false;
                                break;
                            }
                        }
                        if (success)
                        {
                            map.jewels[original.X, original.Y] = Orig;
                            map.jewels[Destination.X, Destination.Y] = Dest;
                            return true;
                        }
                    }
                }
            }
            //

            map.jewels[original.X, original.Y] = Orig;
            map.jewels[Destination.X, Destination.Y] = Dest;
            return false;
        }
        private void GameOver()
        {
            MessageBox.Show($"GameOver; Score={score}, zadny dalsi mozny tah");
            this.Close();
        }
        private void GameOver(string error)
        {
            MessageBox.Show($"GameOver; Score={score}, {error}");
            this.Close();
        }
        private bool canMove(Point original, Point Destination)
        {
            var Orig = map.jewels[original.X, original.Y];
            var Dest = map.jewels[Destination.X, Destination.Y];
            map.jewels[original.X, original.Y] = Dest;
            map.jewels[Destination.X, Destination.Y] = Orig;

            var globalSucces = false;
            var pointsEarned = 0;
            do
            {

                var pointsToDelete = new List<Point>();
                globalSucces = false;
                for (int x = 0; x < map.jewels.GetLength(0); x++)
                {
                    for (int y = 0; y < map.jewels.GetLength(1); y++)
                    {
                        var toCheck = getForCheckPoints(new Point(x, y));
                        foreach (var item in toCheck)
                        {
                            bool success = true;
                            var type = map.get(item.First());
                            foreach (var inneritem in item)
                            {
                                if (type != map.get(inneritem))
                                {
                                    success = false;
                                    break;
                                }
                            }
                            if (success)
                            {
                                pointsToDelete = pointsToDelete.Union(item).ToList();
                                pointsEarned += 3;
                                globalSucces = true;
                            }
                        }
                    }
                }
                if (pointsEarned > 0)
                {
                    score += pointsEarned;
                    UpdateIt();
                    CascadeIt(pointsToDelete);
                }
            }
            while (globalSucces);

            if(pointsEarned>0)
            {
                return true;
            }
            map.jewels[original.X, original.Y] = Orig;
            map.jewels[Destination.X, Destination.Y] = Dest;
            return false;
        }
        private List<List<Point>> getForCheckPoints(Point orig)
        {
            List<List<Point>> returns = new List<List<Point>>();
            if (orig.Y > 1)
            {
                returns.Add(new List<Point>());
                returns.Last().Add(orig);
                returns.Last().Add(new Point(orig.X, orig.Y - 1));
                returns.Last().Add(new Point(orig.X, orig.Y - 2));
            }
            if (orig.X > 1)
            {
                returns.Add(new List<Point>());
                returns.Last().Add(orig);
                returns.Last().Add(new Point(orig.X - 1, orig.Y));
                returns.Last().Add(new Point(orig.X - 2, orig.Y));
            }
            return returns;
        }
        private List<Point> getValidPoints(Point orig)
        {
            List<Point> returns = new List<Point>();
            if(orig.Y>0)
                returns.Add(new Point(orig.X, orig.Y-1));
            if(orig.Y<8)
                returns.Add(new Point(orig.X, orig.Y + 1));
            if (orig.X > 0)
                returns.Add(new Point(orig.X-1, orig.Y));
            if (orig.X < 8)
                returns.Add(new Point(orig.X+1, orig.Y));
            return returns;
        }
        private List<Point> getValidTryPoints(Point orig)
        {
            List<Point> returns = new List<Point>();
            if (orig.Y > 0)
                returns.Add(new Point(orig.X, orig.Y - 1));
            if (orig.X > 0)
                returns.Add(new Point(orig.X - 1, orig.Y));
            return returns;
        }

        private void panel2_Paint(object sender, PaintEventArgs e)
        {
            var size = panel2.Size.Width / 8;
            Graphics g = e.Graphics;
            for (int x = 0; x < map.jewels.GetLength(0); x++)
            {
                int y = 0;
                g.FillRectangle(new SolidBrush(map.peekNext(x).Color), x * size, y * size, size, size);
                g.DrawRectangle(Pens.Black, x * size, y * size, size, size);
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if ((endTime - DateTime.Now).TotalSeconds < 0)
            {
                timer1.Enabled = false;
                GameOver("Dosel Cas");
            }
            UpdateIt();
        }
        private void UpdateIt()
        {
            if(timer1.Enabled)
            this.Text = "Score:" + score + ", "+(endTime- DateTime.Now).TotalSeconds + "sekund zbyva";
            else
                this.Text = "Score:" + score;
        }
    }
    public class MyDisplay : Panel
    {
        public MyDisplay()
        {
            this.DoubleBuffered = true;

            // or

            SetStyle(ControlStyles.AllPaintingInWmPaint, true);
            SetStyle(ControlStyles.OptimizedDoubleBuffer, true);
            UpdateStyles();
        }
    }

}
